﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.DirectX.DirectSound;
using System.IO;

namespace WiiSaber
{
    public class FXObject
    {
        public FXObject(DXSoundControl controller)
        {
            dxController = controller;
        }

        // Fields
        private DXSoundControl dxController = null;
        private bool bLoop = false;
        private SecondaryBuffer secBuffer = null;
        private string strFileName;
        private string strTitle;

        // Properties
        public string FileName
        {
            get
            {
                return this.strFileName;
            }
            set
            {
                this.strFileName = value;
                if (this.strFileName != null)
                {
                    if (this.strFileName.Length > 0)
                    {
                        if (File.Exists(value))
                        {
                            this.secBuffer = dxController.GetFileBuffer(this.strFileName);
                        }
                    }
                    else
                    {
                        this.secBuffer = null;
                    }
                }
            }
        }

        public bool LoopEnabled
        {
            get
            {
                return this.bLoop;
            }
            set
            {
                this.bLoop = value;
            }
        }

        public SecondaryBuffer SecondaryBuffer
        {
            get
            {
                return this.secBuffer;
            }
            set
            {
                this.secBuffer = value;
            }
        }

        public string Title
        {
            get
            {
                return this.strTitle;
            }
            set
            {
                this.strTitle = value;
            }
        }

    }
}
