﻿using System;
using System.Collections.Generic;
using System.Text;

namespace WiiSaber.Wii
{
    public class WiiController
    {
        public delegate void WiimoteStateChangedEvent(WiimoteLib.WiimoteState state);
        public event WiimoteStateChangedEvent WiimoteStateChanged;

        public WiimoteLib.Wiimote Wiimote { get; set; }
        public WiiController(WiimoteLib.Wiimote wiiMote)
        {
            Wiimote = wiiMote;
            Wiimote.WiimoteChanged += new EventHandler<WiimoteLib.WiimoteChangedEventArgs>(HandleWiimoteChanged);
            this.ControllerIndex = -1;
        }

        public void SetLEDs(bool led1, bool led2, bool led3, bool led4)
        {
            Wiimote.SetLEDs(led1, led2, led3, led4);
        }

        public int ControllerIndex { get; set; }

        void HandleWiimoteChanged(object sender, WiimoteLib.WiimoteChangedEventArgs e)
        {
            WiimoteLib.WiimoteState ws = e.WiimoteState;

            if (this.WiimoteStateChanged != null)
            {
                this.WiimoteStateChanged(ws);
            }
        }

        public override string ToString()
        {
            return "Wiimote " + (this.ControllerIndex + 1).ToString();
        }
    }
}
