﻿using System;
using System.Collections.Generic;
using System.Text;
using WiimoteLib;

namespace WiiSaber.Wii
{
    public class WiiControllerManager
    {
        public void Initialize()
        {
            FindWiimotes();
        }

        private int controllerIndex = 0;
        private void FindWiimotes()
        {
            WiimoteLib.WiimoteCollection wC = new WiimoteLib.WiimoteCollection();
            wC.FindAllWiimotes();

            foreach (var wM in wC)
            {
                wM.Connect();

                if (wM.WiimoteState.ExtensionType != ExtensionType.BalanceBoard)
                {
                    wM.SetReportType(InputReport.IRExtensionAccel, IRSensitivity.Maximum, true);
                }

                WiiController wController = new WiiController(wM);
                
                wController.ControllerIndex = controllerIndex;
                WiimoteList.Add(wController);
                controllerIndex += 1;
            }
        }

        public List<WiiController> WiimoteList = new List<WiiController>();

        public void Shutdown()
        {
            foreach (var wController in WiimoteList)
            {
                wController.Wiimote.Disconnect();
            }
        }
    }
}
